%define testname unmet-dependency

Name: repocop-unittest-%testname
Version: 0.03
Release: alt1
BuildArch: noarch
Packager: Igor Vlasenko <viy@altlinux.ru>
Requires: repocop >= 0.08-alt2

Summary: %testname intergration tests for repocop test platform.
Group: Development/Other
License: GPLv2+

%description
The test warns packages that contain unmet dependencies.

%prep

%build
cat > %testname-missing-package.done <<'EOF'
#!/bin/sh
cat > "$REPOCOP_TEST_TMPDIR/tmp.sql" <<EOSQL
.mode tabs
select a.pkgid, requirename from rpm_requires as a left join rpm_provides as b on REQUIRENAME = b.PROVIDENAME where PROVIDENAME is NULL and substr(requirename,0,1)<>'/' and requirename not glob '*(*)';
EOSQL
repocop-sqlite "$REPOCOP_TEST_DBDIR/rpm.db" "$REPOCOP_TEST_TMPDIR/tmp.sql" > $REPOCOP_TEST_TMPDIR/msg
perl -ne 'chomp;@a=split /\t/;system("repocop-test-fail -k $a[0] install dependency $a[1] not found.")' $REPOCOP_TEST_TMPDIR/msg
rm $REPOCOP_TEST_TMPDIR/*
EOF

cat > %testname-no-suitable-version.done <<'EOF'
#!/bin/sh
cat > "$REPOCOP_TEST_TMPDIR/tmp.sql" <<EOSQL
.mode tabs
select a.pkgid, requirename from rpm_requires as a left join rpm_provides as b on REQUIRENAME = b.PROVIDENAME where substr(requirename,0,1)<>'/' and requirename not glob '*(*)' and (PROVIDENAME is not NULL) GROUP BY REQUIRENAME having MAX(rpm_compare_op_evr_evr(REQUIREFLAG,REQUIREVERSION,PROVIDEVERSION))=0;
EOSQL
repocop-sqlite "$REPOCOP_TEST_DBDIR/rpm.db" "$REPOCOP_TEST_TMPDIR/tmp.sql" > $REPOCOP_TEST_TMPDIR/msg
perl -ne 'chomp;@a=split /\t/;system("repocop-test-fail -k $a[0] install dependency $a[1] has no suitable version.")' $REPOCOP_TEST_TMPDIR/msg
rm $REPOCOP_TEST_TMPDIR/*
EOF

cat > %testname-build-missing-package.done <<'EOF'
#!/bin/sh
cat > "$REPOCOP_TEST_TMPDIR/tmp.sql" <<EOSQL
.mode tabs
select a.pkgid, buildrequirename from rpm_buildrequires as a left join rpm_provides as b on BUILDREQUIRENAME = b.PROVIDENAME where PROVIDENAME is NULL and substr(buildrequirename,0,1)<>'/' and buildrequirename not glob '*(*)';
EOSQL
repocop-sqlite "$REPOCOP_TEST_DBDIR/rpm.db" "$REPOCOP_TEST_TMPDIR/tmp.sql" > $REPOCOP_TEST_TMPDIR/msg
perl -ne 'chomp;@a=split /\t/;system("repocop-test-fail -k $a[0] build dependency $a[1] not found.")' $REPOCOP_TEST_TMPDIR/msg
rm $REPOCOP_TEST_TMPDIR/*
EOF

cat > %testname-build-no-suitable-version.done <<'EOF'
#!/bin/sh
cat > "$REPOCOP_TEST_TMPDIR/tmp.sql" <<EOSQL
.mode tabs
select a.pkgid, buildrequirename from rpm_buildrequires as a left join rpm_provides as b on BUILDREQUIRENAME = b.PROVIDENAME where substr(buildrequirename,0,1)<>'/' and buildrequirename not glob '*(*)' and (PROVIDENAME is not NULL) GROUP BY BUILDREQUIRENAME having MAX(rpm_compare_op_evr_evr(BUILDREQUIREFLAG,BUILDREQUIREVERSION,PROVIDEVERSION))=0;
EOSQL
repocop-sqlite "$REPOCOP_TEST_DBDIR/rpm.db" "$REPOCOP_TEST_TMPDIR/tmp.sql" > $REPOCOP_TEST_TMPDIR/msg
perl -ne 'chomp;@a=split /\t/;system("repocop-test-fail -k $a[0] build dependency $a[1] has no suitable version.")' $REPOCOP_TEST_TMPDIR/msg
rm $REPOCOP_TEST_TMPDIR/*
EOF

%install
for i in *.done; do
    testname=`echo $i | sed -e s,.done\$,,`
    install -pD -m 755 $testname.done %buildroot%_datadir/repocop/pkgtests/$testname/done
done

%files
%_datadir/repocop/pkgtests/%testname-*/

%changelog
* Sun Dec 07 2008 Igor Vlasenko <viy@altlinux.ru> 0.03-alt1
- better error messages

* Sat Dec 06 2008 Igor Vlasenko <viy@altlinux.ru> 0.02-alt1
- added tests for BuildRequires:

* Fri Dec 05 2008 Igor Vlasenko <viy@altlinux.ru> 0.01-alt1
- initial version
